<template>
  <q-page class="flex full-width">
    <div class="full-width column">
      <q-form class="SV__settings-form">
        <q-toolbar
          class="text-uppercase text-bold bg-secondary text-white q-pl-lg"
        >
          <q-toolbar-title>Settings</q-toolbar-title>
          <q-btn
            flat
            dense
            label="Save Settings"
            class="q-px-md"
            @click="saveSettings"
          />
        </q-toolbar>

        <div class="row q-px-lg q-pt-lg q-pb-md">
          <q-input
            v-model="apiKey"
            filled
            label="Google API Key"
            :type="isPwd ? 'password' : 'text'"
            class="SV__settings-field"
          >
            <template #append>
              <q-icon
                :name="isPwd ? 'fa-solid fa-eye' : 'fa-solid fa-eye-slash'"
                class="cursor-pointer"
                @click="isPwd = !isPwd"
              />
            </template>
          </q-input>
        </div>

        <div class="row q-px-lg q-pb-lg q-pt-none">
          If you don't have an API key, follow the instructions&nbsp;
          <a
            href="https://developers.google.com/maps/documentation/streetview/get-api-key"
            target="_blank"
            >here</a
          >&nbsp;to get one.
        </div>
      </q-form>
    </div>
  </q-page>
</template>

<script>
import { defineComponent, ref } from "vue";
import { LocalStorage } from "quasar";

export default defineComponent({
  name: "SettingsPage",
  setup() {
    return {
      isPwd: ref(true),
    };
  },
  data() {
    let storedKey = LocalStorage.getItem("google_api_key");

    if (!storedKey) {
      storedKey = "";
    }

    return {
      apiKey: storedKey.trim(),
    };
  },
  methods: {
    saveSettings() {
      this.apiKey = this.apiKey.trim();

      LocalStorage.set("google_api_key", this.apiKey);
    },
  },
});
</script>

<style lang="sass">
.SV

  &__header
    font-size: 2rem

  &__settings-form
    width: 100%

  &__settings-field
    max-width: 600px
    width: 100%
</style>
